/* Project of Group 2, Emilia Vetter and Ben Gronemann */
/* https://eodhistoricaldata.com/financial-apis/list-supported-exchanges/ all supported Exchanges*/

/* First step: Set up API to eodhistorical data, a free api for historical stock data"*/

Say "Fuer welche Aktie moechten Sie die historischen Daten (1 Jahr zurueck); Ticker eingeben, beispielsweise 'AAPL'?"
parse pull ticker

Say "" 
Say "An welcher Boerse ist sie gelistet?"
parse pull exchange


key = "637caa455f6cf5.24861806"


url = "https://eodhistoricaldata.com/api/eod/"ticker"."exchange"?api_token="key /*&order=a&fmt=csv&from="start"&to="end*/

Say "API URL:" url

command = "curl" url -- get stock data

outArr=.array~new -- save in an array

ADDRESS SYSTEM command WITH OUTPUT USING (outArr) ERROR USING (.array~new)

lines =  outArr~size -- how many rows?


excel_array = .array ~new -- create new array



do i = 1 to lines -- fill in desired information 
	text = outArr[i]
	parse var text date "," open "," high "," low "," close "," ad_close "," volume
	
	do j = 1 to 2
	
		SELECT
			WHEN j == 1 THEN excel_array[i,j] = date
			OTHERWISE excel_array[i,j] = high
			/*
			WHEN j == 3 THEN excel_array[i,j] = high
			WHEN j == 4 THEN excel_array[i,j] = low
			WHEN j == 5 THEN excel_array[i,j] = close
			WHEN j == 6 THEN excel_array[i,j] = ad_close
			OTHERWISE excel_array[i,j] = volume
			*/
		end
	end 

end

Say "Excel Array fertig, starte die Anwendung"

excelApplication = .OLEObject~new("Excel.Application") --open excel
excelApplication~visible = .true 
Worksheet = excelApplication~Workbooks~Add~Worksheets[1] 

colTitles = "AB"
colnames =  .array ~of("Date", "High") -- "High", "Low", "Close", "Adjusted Close", "Volume")


do line = 1 to lines -- fill in information
	do col = 1 to colTitles~length 
		colLetter = colTitles[col] -- get column letter
		cell = Worksheet~Range(colLetter||line) 

		if line = 1 then do --column titles
			cell~value = colnames[col]
			cell~font~bold = .true -- make font bold
			
		end
		
		else do 
 			cell~value = excel_array[line, col]
 				
		 end

	end
end


Say "Der Chart wird nun erstellt"

Call SysSleep 5

chart = excelApplication~charts~add     -- add chart       
chart~chartType = excelApplication~getConstant("xlLine") --line chart
plotBy = excelApplication~getConstant("xlColumns")
chart~setSourceData(Worksheet~range("A:B"), plotBy) --plot column A and B
chart~hasTitle = .true

chart~chartTitle~text = "Timeseries of" ticker -- title of chart

homeDir = value("USERPROFILE",,"ENVIRONMENT")
fileName = homeDir"\Chart_Group2_"ticker".png" 
say "fileName:" fileName
chart~Export(fileName) -- export chart as image

excel_name = homeDir"\Chart_Group2_"ticker".xlsx" 
Say excel_name
chart~SaveAs(excel_name) -- save excel file


say "Excel sheet wurde gespeichert und das Bild exportiert, Excel wird beendet"
Say "Powerpoint wird nun gestartet"

Call SysSleep 5
excelApplication~Quit


PP = .OLEObject~New("PowerPoint.Application") -- open pp
PP~Visible = .TRUE 

PP~Presentations~Add~Slides~Add(1, 1) -- add slide
FirstSlide = PP~ActivePresentation~Slides(1)
FirstSlide~Shapes(1)~TextFrame~TextRange = "Time Series of" ticker 
FirstSlide~Shapes(2)~TextFrame~TextRange = "Project of Group 2 in BP1" 

ActivePresentation = PP~ActivePresentation
chart_slide = ActivePresentation~Slides~Add(2, 2) -- add second slide
chart_slide~Shapes(1)~TextFrame~TextRange = "Time Series Chart of" ticker 


chart_slide~Shapes~AddPicture(fileName, -1, 0, 200,120, 600,400) -- add picture with desired width and length

pp_name = homeDir"\Chart_Group2_"ticker".pptx" 
Say pp_name
ActivePresentation~SaveAs(pp_name) -- save slides
Say "Powerpoint Slides wurden gespeichert und Powerpoint wird nun beendet"
Call SysSleep 5
PP~Quit 

